package com.ejie.ab79.dao.protocolos;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.inspecciones.OrigenesInspeccion;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.ab79.model.procedimientos.Procedimientos;
import com.ejie.ab79.model.protocolos.Protocolos;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ProtocolosDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class ProtocolosDaoImpl implements ProtocolosDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDPROTOCOLO", "IDCATEGORIAS",
			"IDTIPOESTABLECIMIENTO", "IDMODALIDAD", "IDDIRECCION", "DESCRIPCIONCASTELLANO", "DESCRIPCIONEUSKERA",
			"FECHAREGISTRO", "USUARIOREGISTRO", "DESCCASTELLANOORIGEN", "DESCEUSKERAORIGEN",
			"DESCCASTELLANOPROCEDIMIENTO", "DESCEUSKERAPROCEDIMIENTO", "DESCCASTELLANODIR", "DESCEUSKERADIR",
			"VALIDADO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<Protocolos> rwMap = new RowMapper<Protocolos>() {
		public Protocolos mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			direccion.setDescripcionCastellano(resultSet.getString("DESCCASTELLANODIR"));
			direccion.setDescripcionEuskera(resultSet.getString("DESCEUSKERADIR"));

			OrigenesInspeccion origen = new OrigenesInspeccion();
			origen.setIdOrigenInspeccion(resultSet.getInt("IDORIGENINSPECCION"));
			origen.setDescripcionCastellano(resultSet.getString("DESCCASTELLANOORIGEN"));
			origen.setDescripcionEuskera(resultSet.getString("DESCEUSKERAORIGEN"));

			Procedimientos procedimiento = new Procedimientos();
			procedimiento.setIdProcedimiento(resultSet.getInt("IDPROCEDIMIENTO"));
			if (resultSet.wasNull()) {
				procedimiento.setIdProcedimiento(null);
			}
			procedimiento.setDescripcionEs(resultSet.getString("DESCCASTELLANOPROCEDIMIENTO"));
			procedimiento.setDescripcionEu(resultSet.getString("DESCEUSKERAPROCEDIMIENTO"));

			Protocolos protocolos = new Protocolos();

			protocolos.setIdProtocolo(resultSet.getInt("IDPROTOCOLO"));
			protocolos.setCategoriaEstablecimiento(resultSet.getString("IDCATEGORIAS"));
			protocolos.setTipoEstablecimiento(resultSet.getString("IDTIPOESTABLECIMIENTO"));
			protocolos.setModalidadEstablecimiento(resultSet.getString("IDMODALIDAD"));
			protocolos.setDireccion(direccion);
			protocolos.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			protocolos.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));
			protocolos.setOrigen(origen);
			protocolos.setProcedimiento(procedimiento);
			protocolos.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			protocolos.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			protocolos.setValidado(resultSet.getInt("VALIDADO"));

			return protocolos;
		}
	};

	private RowMapper<Protocolos> rwMapFindAllREST = new RowMapper<Protocolos>() {
		public Protocolos mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Protocolos protocolos = new Protocolos();

			protocolos.setIdProtocolo(resultSet.getInt("IDPROTOCOLO"));
			protocolos.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			protocolos.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));

			return protocolos;
		}
	};

	private RowMapper<Protocolos> rwMapPK = new RowMapper<Protocolos>() {
		public Protocolos mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Protocolos(resultSet.getInt("IDPROTOCOLO"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<Protocolos>> rwMapJerarquia = new RowMapper<JerarquiaDto<Protocolos>>() {
		public JerarquiaDto<Protocolos> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			direccion.setDescripcionCastellano(resultSet.getString("DESCCASTELLANODIR"));
			direccion.setDescripcionEuskera(resultSet.getString("DESCEUSKERADIR"));

			OrigenesInspeccion origen = new OrigenesInspeccion();
			origen.setIdOrigenInspeccion(resultSet.getInt("IDORIGENINSPECCION"));
			origen.setDescripcionCastellano(resultSet.getString("DESCCASTELLANOORIGEN"));
			origen.setDescripcionEuskera(resultSet.getString("DESCEUSKERAORIGEN"));

			Procedimientos procedimiento = new Procedimientos();
			procedimiento.setIdProcedimiento(resultSet.getInt("IDPROCEDIMIENTO"));
			procedimiento.setDescripcionEs(resultSet.getString("DESCCASTELLANOPROCEDIMIENTO"));
			procedimiento.setDescripcionEu(resultSet.getString("DESCEUSKERAPROCEDIMIENTO"));

			Protocolos protocolos = new Protocolos();

			protocolos.setIdProtocolo(resultSet.getInt("IDPROTOCOLO"));
			protocolos.setCategoriaEstablecimiento(resultSet.getString("IDCATEGORIAS"));
			protocolos.setTipoEstablecimiento(resultSet.getString("IDTIPOESTABLECIMIENTO"));
			protocolos.setModalidadEstablecimiento(resultSet.getString("IDMODALIDAD"));
			protocolos.setDireccion(direccion);
			protocolos.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			protocolos.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));
			protocolos.setOrigen(origen);
			protocolos.setProcedimiento(procedimiento);
			protocolos.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			protocolos.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));

			// Protocolos protocolos = new
			// Protocolos(resultSet.getInt("ID_PROTOCOLO"),
			// resultSet.getString("ID_CATEGORIAS"),
			// resultSet.getString("ID_TIPO_ESTABLECIMIENTO"),
			// resultSet.getString("ID_MODALIDAD"),
			// resultSet.getInt("ID_DIRECCION"),
			// resultSet.getString("DESCRIPCION_CASTELLANO"),
			// resultSet.getString("DESCRIPCION_EUSKERA"),
			// resultSet.getDate("FECHA_REGISTRO"),
			// resultSet.getString("USUARIO_REGISTRO"));

			JerarquiaDto<Protocolos> jerarquia = new JerarquiaDto<Protocolos>();
			jerarquia.setModel(protocolos);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the Protocolos table.
	 *
	 * @param protocolos
	 *            Protocolos
	 * @return Protocolos
	 */
	public Protocolos add(Protocolos protocolos) {

		Integer idProtocolo = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7910T00.NEXTVAL FROM DUAL",
				Integer.class);
		protocolos.setIdProtocolo(idProtocolo);

		String query = "INSERT INTO PROTOCOLOS (ID_PROTOCOLO, ID_CATEGORIAS, ID_TIPO_ESTABLECIMIENTO, ID_MODALIDAD, ID_DIRECCION, DESCRIPCION_CASTELLANO, DESCRIPCION_EUSKERA, ID_ORIGEN_INSPECCION, ID_PROCEDIMIENTO, FECHA_REGISTRO, USUARIO_REGISTRO, VALIDADO) VALUES (?,?,?,?,?,?,?,?,?,?,?,?)";
		this.jdbcTemplate.update(query, protocolos.getIdProtocolo(), protocolos.getCategoriaEstablecimiento(),
				protocolos.getTipoEstablecimiento(), protocolos.getModalidadEstablecimiento(),
				protocolos.getDireccion().getIdDireccion(), protocolos.getDescripcionCastellano(),
				protocolos.getDescripcionEuskera(), protocolos.getOrigen().getIdOrigenInspeccion(),
				protocolos.getProcedimiento().getIdProcedimiento(), protocolos.getFechaRegistro(),
				protocolos.getUsuarioRegistro(), Constantes.INFORME_INACTIVO);
		return protocolos;
	}

	/**
	 * Updates a single row in the Protocolos table.
	 *
	 * @param protocolos
	 *            Protocolos
	 * @return Protocolos
	 */
	public Protocolos update(Protocolos protocolos) {
		String query = "UPDATE PROTOCOLOS SET ID_CATEGORIAS=?, ID_TIPO_ESTABLECIMIENTO=?, ID_MODALIDAD=?, ID_DIRECCION=?, DESCRIPCION_CASTELLANO=?, DESCRIPCION_EUSKERA=?, ID_ORIGEN_INSPECCION=?, ID_PROCEDIMIENTO=?, FECHA_ULTMODIFICACION=?, USUARIO_ULTMODIFICACION=? WHERE ID_PROTOCOLO=?";
		this.jdbcTemplate.update(query, protocolos.getCategoriaEstablecimiento(), protocolos.getTipoEstablecimiento(),
				protocolos.getModalidadEstablecimiento(), protocolos.getDireccion().getIdDireccion(),
				protocolos.getDescripcionCastellano(), protocolos.getDescripcionEuskera(),
				protocolos.getOrigen().getIdOrigenInspeccion(), protocolos.getProcedimiento().getIdProcedimiento(),
				protocolos.getFechaUltmodificacion(), protocolos.getUsuarioUltmodificacion(),
				protocolos.getIdProtocolo());
		return protocolos;
	}

	/**
	 * Finds a single row in the Protocolos table.
	 *
	 * @param protocolos
	 *            Protocolos
	 * @return Protocolos
	 */
	@Transactional(readOnly = true)
	public Protocolos find(Protocolos protocolos) {
		String query = "SELECT t1.ID_PROTOCOLO IDPROTOCOLO, t1.ID_CATEGORIAS IDCATEGORIAS, t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO, t1.ID_MODALIDAD IDMODALIDAD, t1.ID_DIRECCION IDDIRECCION, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.VALIDADO VALIDADO, t2.DESCRIPCION_CASTELLANO DESCCASTELLANODIR, t2.DESCRIPCION_EUSKERA DESCEUSKERADIR, t3.DESCRIPCION_CASTELLANO DESCCASTELLANOORIGEN, t3.DESCRIPCION_EUSKERA DESCEUSKERAORIGEN, t4.DESCRIPCION_CASTELLANO DESCCASTELLANOPROCEDIMIENTO, t4.DESCRIPCION_EUSKERA DESCEUSKERAPROCEDIMIENTO FROM PROTOCOLOS t1, DIRECCIONES t2, ORIGENES_INSPECCION t3, PROCEDIMIENTOS t4  WHERE t1.ID_PROTOCOLO = ? AND t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_ORIGEN_INSPECCION = t3.ID_ORIGEN_INSPECCION AND t1.ID_PROCEDIMIENTO = t4.ID_PROCEDIMIENTO(+)  ";

		List<Protocolos> protocolosList = this.jdbcTemplate.query(query, this.rwMap, protocolos.getIdProtocolo());
		return DataAccessUtils.uniqueResult(protocolosList);
	}

	/**
	 * Finds a single row in the Protocolos table.
	 *
	 * @param protocolos
	 *            Protocolos
	 * @return Protocolos
	 */
	@Transactional(readOnly = true)
	public Protocolos findProtocolo(Protocolos protocolos) {
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PROTOCOLO IDPROTOCOLO, t1.ID_DIRECCION IDDIRECCION, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.ID_CATEGORIAS IDCATEGORIAS, t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO, t1.ID_MODALIDAD IDMODALIDAD, t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.VALIDADO VALIDADO, t2.DESCRIPCION_CASTELLANO DESCCASTELLANODIR, t2.DESCRIPCION_EUSKERA DESCEUSKERADIR, t3.DESCRIPCION_CASTELLANO DESCCASTELLANOORIGEN, t3.DESCRIPCION_EUSKERA DESCEUSKERAORIGEN, t4.DESCRIPCION_CASTELLANO DESCCASTELLANOPROCEDIMIENTO, t4.DESCRIPCION_EUSKERA DESCEUSKERAPROCEDIMIENTO FROM PROTOCOLOS t1, DIRECCIONES t2, ORIGENES_INSPECCION t3, PROCEDIMIENTOS t4");

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMapWS(protocolos, false);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_ORIGEN_INSPECCION = t3.ID_ORIGEN_INSPECCION AND t1.ID_PROCEDIMIENTO = t4.ID_PROCEDIMIENTO (+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		List<Protocolos> protocolosList = this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());

		if(protocolosList != null && !protocolosList.isEmpty() && protocolosList.size() == 1 ){
			return DataAccessUtils.uniqueResult(protocolosList);
		}else{
			return null;
		}
	}

	/**
	 * Removes a single row in the Protocolos table.
	 *
	 * @param protocolos
	 *            Protocolos
	 * @return
	 */
	public void remove(Protocolos protocolos) {
		String query = "DELETE FROM PROTOCOLOS WHERE ID_PROTOCOLO=?";
		this.jdbcTemplate.update(query, protocolos.getIdProtocolo());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<Protocolos> getMultiple(Protocolos filterProtocolos, TableRequestDto tableRequestDto,
			Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterProtocolos, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, Protocolos.class, params,
				"ID_PROTOCOLO");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the Protocolos table.
	 *
	 * @param protocolos
	 *            Protocolos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<Protocolos>
	 */
	@Transactional(readOnly = true)
	public List<Protocolos> findAll(Protocolos protocolos, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_PROTOCOLO IDPROTOCOLO,t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.ID_MODALIDAD IDMODALIDAD,t1.ID_DIRECCION IDDIRECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.VALIDADO VALIDADO, t2.DESCRIPCION_CASTELLANO DESCCASTELLANODIR, t2.DESCRIPCION_EUSKERA DESCEUSKERADIR, t3.DESCRIPCION_CASTELLANO DESCCASTELLANOORIGEN, t3.DESCRIPCION_EUSKERA DESCEUSKERAORIGEN, t4.DESCRIPCION_CASTELLANO DESCCASTELLANOPROCEDIMIENTO, t4.DESCRIPCION_EUSKERA DESCEUSKERAPROCEDIMIENTO ");
		query.append("FROM PROTOCOLOS t1, DIRECCIONES t2, ORIGENES_INSPECCION t3, PROCEDIMIENTOS t4 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(protocolos);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_ORIGEN_INSPECCION = t3.ID_ORIGEN_INSPECCION AND t1.ID_PROCEDIMIENTO = t4.ID_PROCEDIMIENTO(+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, ProtocolosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<Protocolos>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<Protocolos> findAllREST(Protocolos filterProtocolos) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_PROTOCOLO IDPROTOCOLO, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		query.append("FROM PROTOCOLOS t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(filterProtocolos);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return (List<Protocolos>) this.jdbcTemplate.query(query.toString(), this.rwMapFindAllREST, params.toArray());
	}

	/**
	 * Finds rows in the Protocolos table using like.
	 *
	 * @param protocolos
	 *            Protocolos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Protocolos>
	 */
	@Transactional(readOnly = true)
	public List<Protocolos> findAllLike(Protocolos protocolos, TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_PROTOCOLO IDPROTOCOLO,t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.ID_MODALIDAD IDMODALIDAD,t1.ID_DIRECCION IDDIRECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.VALIDADO VALIDADO, t2.DESCRIPCION_CASTELLANO DESCCASTELLANODIR, t2.DESCRIPCION_EUSKERA DESCEUSKERADIR, t3.DESCRIPCION_CASTELLANO DESCCASTELLANOORIGEN, t3.DESCRIPCION_EUSKERA DESCEUSKERAORIGEN, t4.DESCRIPCION_CASTELLANO DESCCASTELLANOPROCEDIMIENTO, t4.DESCRIPCION_EUSKERA DESCEUSKERAPROCEDIMIENTO ");
		query.append(" FROM PROTOCOLOS t1, DIRECCIONES t2, ORIGENES_INSPECCION t3, PROCEDIMIENTOS t4 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(protocolos, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_ORIGEN_INSPECCION = t3.ID_ORIGEN_INSPECCION AND t1.ID_PROCEDIMIENTO = t4.ID_PROCEDIMIENTO (+)");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query);
		}

		return (List<Protocolos>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public Integer calcularNumPreguntasProtocolo(Protocolos protocolo) {
		String query = "SELECT COUNT(1) NUMPREGUNTASPROTOCOLO FROM REL_PRO_PRE t1, PREGUNTAS_PROTOCOLO t2 WHERE t1.ID_PROTOCOLO = ? AND t1.ID_PREGUNTA_PROTOCOLO = t2.ID_PREGUNTA_PROTOCOLO";
		List<Object> params = new ArrayList<Object>();
		params.add(protocolo.getIdProtocolo());
		return this.jdbcTemplate.queryForObject(query, params.toArray(), Integer.class);
	}

	@Override
	public Integer calcularNumeroRespuestasProtocolo(Protocolos protocolo) {
		String query = "SELECT COUNT(1) NUMRESPUESTASPROTOCOLO FROM REL_PRO_PRE t1, PREGUNTAS_PROTOCOLO t2, RESPUESTAS_PROTOCOLO t3 WHERE t1.ID_PROTOCOLO = ? AND t1.ID_PREGUNTA_PROTOCOLO = t2.ID_PREGUNTA_PROTOCOLO AND t1.ID_REL_PRO_PRE = t3.ID_REL_PRO_PRE";
		List<Object> params = new ArrayList<Object>();
		params.add(protocolo.getIdProtocolo());
		return this.jdbcTemplate.queryForObject(query, params.toArray(), Integer.class);
	}

	@Override
	public Integer calcularNumeroRespuestasValidar(Protocolos protocolo) {
		String query = "SELECT COUNT(1) NUMRESPUESTASVALIDAR FROM INSPECCIONES t1, PREGUNTAS_EXPEDIENTE t2, RESPUESTAS_EXPEDIENTE t3 WHERE t1.ID_PROTOCOLO = ? AND t1.ID_INSPECCION = t2.ID_INSPECCION AND t2.ID_PREGUNTA_EXPEDIENTE = t3.ID_PREGUNTA_EXPEDIENTE AND t2.VALOR_VALIDAR IS NOT NULL";
		List<Object> params = new ArrayList<Object>();
		params.add(protocolo.getIdProtocolo());
		return this.jdbcTemplate.queryForObject(query, params.toArray(), Integer.class);
	}

	@Override
	public Integer calcularNumeroInspecciones(Protocolos protocolo) {
		String query = "SELECT COUNT(1) NUMINSPECCIONES FROM INSPECCIONES t1 WHERE t1.ID_PROTOCOLO = ?";
		List<Object> params = new ArrayList<Object>();
		params.add(protocolo.getIdProtocolo());
		return this.jdbcTemplate.queryForObject(query, params.toArray(), Integer.class);
	}

	@Override 
	public Protocolos validarInforme(Protocolos protocolo) {
		String query = "UPDATE PROTOCOLOS SET VALIDADO = " + Constantes.INFORME_ACTIVO + " WHERE ID_PROTOCOLO = ?";

		this.jdbcTemplate.update(query, protocolo.getIdProtocolo());
		return protocolo;
	}

	@Override
	public Protocolos invalidarInforme(Protocolos protocolo) {
		String query = "UPDATE PROTOCOLOS SET VALIDADO = " + Constantes.INFORME_INACTIVO + " WHERE ID_PROTOCOLO = ?";

		this.jdbcTemplate.update(query, protocolo.getIdProtocolo());
		return protocolo;
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the Protocolos table.
	 *
	 * @param protocolos
	 *            Protocolos
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(Protocolos protocolos) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM PROTOCOLOS t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(protocolos);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the Protocolos table using like.
	 *
	 * @param protocolos
	 *            Protocolos
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(Protocolos protocolos, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT COUNT(1) FROM PROTOCOLOS t1, DIRECCIONES t2, ORIGENES_INSPECCION t3, PROCEDIMIENTOS t4 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(protocolos, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_ORIGEN_INSPECCION = t3.ID_ORIGEN_INSPECCION AND t1.ID_PROCEDIMIENTO = t4.ID_PROCEDIMIENTO (+) ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of Protocolos selected for rup_table
	 *
	 * @param protocolos
	 *            Protocolos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Protocolos>>
	 */
	@Override
	public List<TableRowDto<Protocolos>> reorderSelection(Protocolos protocolos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_PROTOCOLO IDPROTOCOLO,t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.ID_MODALIDAD IDMODALIDAD,t1.ID_DIRECCION IDDIRECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t1.ID_PROCEDIMIENTO IDPROCEDIMIENTO, t1.VALIDADO VALIDADO, t2.DESCRIPCION_CASTELLANO DESCCASTELLANODIR, t2.DESCRIPCION_EUSKERA DESCEUSKERADIR, t3.DESCRIPCION_CASTELLANO DESCCASTELLANOORIGEN, t3.DESCRIPCION_EUSKERA DESCEUSKERAORIGEN, t4.DESCRIPCION_CASTELLANO DESCCASTELLANOPROCEDIMIENTO, t4.DESCRIPCION_EUSKERA DESCEUSKERAPROCEDIMIENTO ");
		// FROM
		query.append(" FROM PROTOCOLOS t1, DIRECCIONES t2, ORIGENES_INSPECCION t3, PROCEDIMIENTOS t4 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(protocolos, startsWith);
		StringBuilder where = new StringBuilder(
				" WHERE 1=1 AND t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_ORIGEN_INSPECCION = t3.ID_ORIGEN_INSPECCION AND t1.ID_PROCEDIMIENTO = t4.ID_PROCEDIMIENTO (+)");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto, Protocolos.class,
				filterParamList, "ID_PROTOCOLO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Protocolos>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            Protocolos
	 * @param searchParams
	 *            Protocolos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Protocolos>>
	 */
	@Override
	public List<TableRowDto<Protocolos>> search(Protocolos filterParams, Protocolos searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PROTOCOLO IDPROTOCOLO,t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.ID_MODALIDAD IDMODALIDAD,t1.ID_DIRECCION IDDIRECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM PROTOCOLOS t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto, Protocolos.class,
				filterParamList, searchSQL, searchParamList, from_alias, "ID_PROTOCOLO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<Protocolos>(this.rwMapPK, tableRequestDto), filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterprotocolos
	 *            Protocolos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(Protocolos filterprotocolos, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PROTOCOLO IDPROTOCOLO,t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.ID_MODALIDAD IDMODALIDAD,t1.ID_DIRECCION IDDIRECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM PROTOCOLOS t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterprotocolos, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto, Protocolos.class,
				query, params, "ID_PROTOCOLO");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical Protocolos table.
	 *
	 * @param filterProtocolos
	 *            Protocolos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<Protocolos>>
	 */
	@Override
	public List<JerarquiaDto<Protocolos>> findAllLikeJerarquia(Protocolos filterProtocolos,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_PROTOCOLO IDPROTOCOLO,t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.ID_MODALIDAD IDMODALIDAD,t1.ID_DIRECCION IDDIRECCION,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM PROTOCOLOS t1 ");
		List<String> from = new ArrayList<String>();
		from.add("PROTOCOLOS");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterProtocolos, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_PROTOCOLO", "ID_PADRE", "NOMBRE",
				from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					ProtocolosDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterProtocolos
	 *            Protocolos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(Protocolos filterProtocolos, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM PROTOCOLOS t1 ");
		List<String> from = new ArrayList<String>();
		from.add("PROTOCOLOS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterProtocolos, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_PROTOCOLO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterProtocolos
	 *            Protocolos
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<Protocolos>>
	 */
	@Override
	public List<TableRowDto<Protocolos>> findAllChild(Protocolos filterProtocolos, TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM PROTOCOLOS t1 ");
		List<String> from = new ArrayList<String>();
		from.add("PROTOCOLOS");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterProtocolos, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_PROTOCOLO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<Protocolos>(this.rwMapPK, "ID_PROTOCOLO"), params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Protocolos entity
	 *
	 * @param protocolos
	 *            Protocolos Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(Protocolos protocolos) {

		StringBuilder where = new StringBuilder(ProtocolosDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (protocolos != null && protocolos.getIdProtocolo() != null) {
			where.append(" AND t1.ID_PROTOCOLO = ?");
			params.add(protocolos.getIdProtocolo());
		}
		if (protocolos != null && protocolos.getCategoriaEstablecimiento() != null) {
			where.append(" AND t1.ID_CATEGORIAS = ?");
			params.add(protocolos.getCategoriaEstablecimiento());
		}
		if (protocolos != null && protocolos.getTipoEstablecimiento() != null) {
			where.append(" AND t1.ID_TIPO_ESTABLECIMIENTO = ?");
			params.add(protocolos.getTipoEstablecimiento());
		}
		if (protocolos != null && protocolos.getModalidadEstablecimiento() != null) {
			where.append(" AND t1.ID_MODALIDAD = ?");
			params.add(protocolos.getModalidadEstablecimiento());
		}
		if (protocolos != null && protocolos.getDireccion() != null
				&& protocolos.getDireccion().getIdDireccion() != null) {
			where.append(" AND t1.ID_DIRECCION = ?");
			params.add(protocolos.getDireccion().getIdDireccion());
		}
		if (protocolos != null && protocolos.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(protocolos.getDescripcionCastellano());
		}
		if (protocolos != null && protocolos.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(protocolos.getDescripcionEuskera());
		}
		if (protocolos != null && protocolos.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(protocolos.getFechaRegistro());
		}
		if (protocolos != null && protocolos.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(protocolos.getUsuarioRegistro());
		}
		if (protocolos != null && protocolos.getOrigen() != null
				&& protocolos.getOrigen().getIdOrigenInspeccion() != null) {
			where.append(" AND t1.ID_ORIGEN_INSPECCION = ?");
			params.add(protocolos.getOrigen().getIdOrigenInspeccion());
		}
		if (protocolos != null && protocolos.getValidado() != null) {
			where.append(" AND t1.VALIDADO = ?");
			params.add(protocolos.getValidado());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Protocolos entity
	 *
	 * @param protocolos
	 *            Protocolos Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(Protocolos protocolos, Boolean startsWith) {

		StringBuilder where = new StringBuilder(ProtocolosDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (protocolos != null && protocolos.getIdProtocolo() != null) {
			where.append(" AND t1.ID_PROTOCOLO = ?");
			params.add(protocolos.getIdProtocolo());
		}
		if (protocolos != null && protocolos.getCategoriaEstablecimiento() != null) {
			where.append(" AND UPPER(t1.ID_CATEGORIAS) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(protocolos.getCategoriaEstablecimiento().toUpperCase() + "%");
			} else {
				params.add("%" + protocolos.getCategoriaEstablecimiento().toUpperCase() + "%");
			}
			where.append(" AND t1.ID_CATEGORIAS IS NOT NULL");
		}
		if (protocolos != null && protocolos.getTipoEstablecimiento() != null) {
			where.append(" AND UPPER(t1.ID_TIPO_ESTABLECIMIENTO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(protocolos.getTipoEstablecimiento().toUpperCase() + "%");
			} else {
				params.add("%" + protocolos.getTipoEstablecimiento().toUpperCase() + "%");
			}
			where.append(" AND t1.ID_TIPO_ESTABLECIMIENTO IS NOT NULL");
		}
		if (protocolos != null && protocolos.getModalidadEstablecimiento() != null) {
			where.append(" AND UPPER(t1.ID_MODALIDAD) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(protocolos.getModalidadEstablecimiento().toUpperCase() + "%");
			} else {
				params.add("%" + protocolos.getModalidadEstablecimiento().toUpperCase() + "%");
			}
			where.append(" AND t1.ID_MODALIDAD IS NOT NULL");
		}
		if (protocolos != null && protocolos.getDireccion() != null
				&& protocolos.getDireccion().getIdDireccion() != null) {
			where.append(" AND t1.ID_DIRECCION = ?");
			params.add(protocolos.getDireccion().getIdDireccion());
		}
		if (protocolos != null && protocolos.getDescripcionCastellano() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_CASTELLANO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(protocolos.getDescripcionCastellano().toUpperCase() + "%");
			} else {
				params.add("%" + protocolos.getDescripcionCastellano().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_CASTELLANO IS NOT NULL");
		}
		if (protocolos != null && protocolos.getDescripcionEuskera() != null) {
			where.append(" AND UPPER(t1.DESCRIPCION_EUSKERA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(protocolos.getDescripcionEuskera().toUpperCase() + "%");
			} else {
				params.add("%" + protocolos.getDescripcionEuskera().toUpperCase() + "%");
			}
			where.append(" AND t1.DESCRIPCION_EUSKERA IS NOT NULL");
		}
		if (protocolos != null && protocolos.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(protocolos.getFechaRegistro());
		}
		if (protocolos != null && protocolos.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(protocolos.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + protocolos.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (protocolos != null && protocolos.getOrigen() != null
				&& protocolos.getOrigen().getIdOrigenInspeccion() != null) {
			where.append(" AND t1.ID_ORIGEN_INSPECCION = ?");
			params.add(protocolos.getOrigen().getIdOrigenInspeccion());
		}
		if (protocolos != null && protocolos.getValidado() != null) {
			where.append(" AND t1.VALIDADO = ?");
			params.add(protocolos.getValidado());
		}
		if (protocolos != null && protocolos.getProcedimiento() != null
				&& protocolos.getProcedimiento().getIdProcedimiento() != null) {
			where.append(" AND t1.ID_PROCEDIMIENTO = ?");
			params.add(protocolos.getProcedimiento().getIdProcedimiento());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the Protocolos entity
	 *
	 * @param protocolos
	 *            Protocolos Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMapWS(Protocolos protocolos, Boolean startsWith) {

		StringBuilder where = new StringBuilder(ProtocolosDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (protocolos != null && protocolos.getCategoriaEstablecimiento() != null) {
			where.append(" AND t1.ID_CATEGORIAS = ?");
			params.add(protocolos.getCategoriaEstablecimiento());
		}
		if (protocolos != null && protocolos.getTipoEstablecimiento() != null) {
			where.append(" AND t1.ID_TIPO_ESTABLECIMIENTO = ?");
			params.add(protocolos.getTipoEstablecimiento());
		}
		if (protocolos != null && protocolos.getModalidadEstablecimiento() != null) {
			where.append(" AND t1.ID_MODALIDAD = ?");
			params.add(protocolos.getModalidadEstablecimiento());
		}
		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
